#ifndef _processandupdate_h_
#define _processandupdate_h_


#include <stdio.h>


#define UNDEFFORMATINPUT	-1
#define NEWDMFORMATINPUT	1
#define DMFORMATFILEINPUT	2


#define NEWDMFORMATFIRSTLINE	"newdmformat"
#define SOURCELINEHEAD		"source= "
#define ROOTEDATHEAD		"rootedAt= "


#define UNDEFLINETYPE		0

#define BLANKLINETYPE		1
#define COMMENTLINETYPE		2
#define ERRORCOMMENTLINETYPE	3
#define SOURCELINETYPE		4
#define ROOTEDATLINETYPE	5
#define ATTSLINETYPE		6  /* RDN or non-RDN attribute value assertion */
#define MODRDNLINETYPE		7
#define NEWDMFORMATLINETYPE	8
#define OTHERLINETYPE		9  /* E.g. empty string "" */
#define ROOTEDATMODRDNATTSORBLANKLINETYPE 10
#define ROOTEDATATTSORBLANKLINETYPE 11
#define ROOTEDATORATTSLINETYPE 	12
#define ANYLINETYPE		13

#define MULTIATTRVALSCHAR	'&'
#define MULTIATTRPARTSCHAR	'#'
#define	ATTRTYPEDELIM		'='
#define COMMENTCHAR		'#'
#define RDNDELIMITER		'@'
#define UFNRDNDELIMITER		','


/* Bulk load leading characters.. */

#define ALLBULKLOADCHARS	"*$!+-><"

#define MODRDNCHAR		'*'
#define ADDRDNCHAR		'$'
#define DELETERDNCHAR		'!'
#define ADDATTRCHAR		'+'
#define DELETEATTRCHAR		'-'
#define ADDVALUECHAR		'>'
#define DELETEVALUECHAR		'<'


/* Note: the modify RDN action is handled differently within "updatedirectory.c" */
#define NOACTIONREQ		0
#define ADDRDNACTION		1
#define DELETERDNACTION		2
#define MODRDNACTION		3
#define ADDATTRACTION		4
#define DELETEATTRACTION	5
#define ADDVALUEACTION		6
#define DELETEVALUEACTION	7


struct attributeLine {

	char  *	attrLinecp ;	    /* Will not include a leading newdmformat character */

	int	attrUsed ;	    /* For localised processing */

	int	attrIsMasteredByCurrentSource ; /* For localised processing */

	char *  errorMsgcp ;

	int	actionDefinedByAttrLine ; /* ADDATTRACTION, DELETEATTRACTION, ADDVALUEACTION or DELETEVALUEACTION */

	int	modificationInitiated ;   /* EM_ADDATTRIBUTE, EM_ADDVALUES, EM_REMOVEATTRIBUTE or EM_REMOVEVALUES */
        
	int     nthAttrOfThisType ; /* Keeps track of the number of instances
				       of this attributes type held within this
				       attributeLine linked list upto and including
                                       the current node. They are set up by a call
				       to findAttrTypeSequences() */
	AttributeType  at ;
	AttributeValue av ;
	
	struct 	attributeLine * nextAttrLinep ;
} ;

#define NULLALP	((struct attributeLine *) 0 )

/* RDN blocks for a single rootedAt statement.. */
struct rootedAtAttributes {

	char  * rdnLinecp ;	    /* will include any leading newdmformat character */

	RDN	rdn ;
	RDN	modRdn ;

	DN	rootedAtDN ;

	char *	attrSequenceErrorMsgcp ;	
	struct 	attributeLine * attrLinep ;

	struct  rootedAtAttributes * nextRootedAtAttrsp ;
} ;

#define NULLRAA	((struct rootedAtAttributes *) 0 )

#define PARSEAFILENAME		"bulkloadparseAfile"
#define PARSEBFILENAME		"bulkloadparseBfile"
#define PARSECFILENAME		"bulkloadparseCfile"
#define PARSEDFILENAME		"bulkloadparseDfile"
#define	DRAFTFILENAME		"bulkloaddraftfile"


#define MINOUTPUTFILEINDEX	0
#define OUTPUTDRAFTFILE		0
#define	OUTPUTDONEFILE		1
#define OUTPUTNOACTIONFILE	2
#define OUTPUTPROBLEMFILE	3
#define MAXOUTPUTFILEINDEX	3
#define PROCESSTHEUPDATE	4
#define INVALIDPROCESSING	5

#define NUMPROCESSFILETOKENS	6


struct	outputFileDetails {

	FILE *	outFilep ;
	char	outputFilename[ SMALLBUFLEN ] ;

	int	RootedAtOutput ;
	char *	RootedAtDNcp ;
	char *	SubDirListResolvedParentDNcp ;
	
	int	RDNoutput ;
	char *	rdnLinecp ;
} ;


#endif
